/**
 * \file
 *
 * \brief main ̧
 *
 * 쌠 (c) 2015 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *    Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *    ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *    (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *    ł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
/*
 * xFAQ: <a href="http://www.atmel.com/design-support/">Atmelx</a>q˂ĂB
 */

/* == ݸٰ ̧ ========================================================== */

#include <avr/sleep.h>
#include "touch_api_ptc.h"

/* == #` ================================================================= */

#define JOIN( x, y )				x ## y
#define REG( REGISTER, SIDE )		JOIN( REGISTER, SIDE )

#define SET_GPIO_PIN(port , pin)	REG(PORT, port) |= (1 << pin)
#define RESET_GPIO_PIN(port, pin)	REG(PORT, port) &= ~(1 << pin)

/* == ^ ==================================================================== */

/* == 萔 ================================================================== */

#define DEF_MCU_CLOCK_PRESCALER		1u
#define DEF_TIME_PERIOD_1MSEC		8u

#define LED_0_PORT					B
#define LED_0_PIN					5u

/* == S萔 ============================================================== */

/* == Sϐ ============================================================== */

volatile uint16_t touch_time_counter = 0u;

/* == ̧͈ٔ (ÓI)ϐ =================================================== */

/* == ̧͈ٔ (ÓI)֐^錾 =========================================== */

/*! \brief MCUۯOu`Ԑݒٰ */
static void configure_prescaler(const uint8_t MCU_Clock_Prescaler);

/*! \brief /ٰ */
static void timer_init(void);

/*! \brief ߰ ݏٰ */
static void configure_port_pins(void);

/* == ̧͈ٔ (ÓI)֐` =============================================== */

/*! \brief ۯ8MHzőŝmɂ邽߂ɼёOu1(Ȃ)ɐݒ
 *
 *  \param	Sys_Clock_Prescaler	: MCUۯOul
 *  \param	MCU_Clock_Prescaler	: MCUۯOu
 *
 *  \return	void
 */
static void configure_prescaler(const uint8_t MCU_Clock_Prescaler)
{
	/*  ۯOu1`8MHzɐݒ */
	/* SĂ4܂B */
	__asm__ __volatile__  (
		"ldi r16, 0x80; \n\t"
		"sts 0x61, r16; \n\t"
		"sts 0x61, %0; \n\t "
		: /* oڼ޽Ȃ */
		: "r"(MCU_Clock_Prescaler) /* ڼ޽ꗗ */
		: "r17" /* jꗗ */
	);
}/*configure_prescaler*/

/*! \brief /0ꊄ荞ݏٰ
 *
 *  \param	void
 *  \return	void
 */
ISR(TIMER0_OVF_vect)
{
	SET_GPIO_PIN(LED_0_PORT,LED_0_PIN);
}

/*! \brief /0rAv荞ݏٰ
 *
 *  \param	void
 *  \return	void
 */
ISR(TIMER0_COMPA_vect)
{
	RESET_GPIO_PIN(LED_0_PORT,LED_0_PIN);
}

/*! \brief /21ms̔rAv荞݂Ɍ`Ԑݒ
 *
 *  \param	void
 *  \return	void
 */
static void timer_init(void)
{
	TCCR2A = 0x00u | (1u << WGM21);						// TC2rvŉ(CTC)ɍ\ݒ
	TCNT2 = 0x00u;										// TC20ɐݒ
	OCR2A = DEF_TIME_PERIOD_1MSEC;						// rA1ms𑪂悤ɐݒ
	TIFR2 = 0x00 | (1u << OCF2A);						// rAv荞ݗv׸ނ
	TIMSK2 = 0x00 | ( 1u << OCIE2A);					// TC2rAv荞݋
	TCCR2B = ((1 << CS20) | (1 << CS21) | (1<< CS22));	// 1024TC2n

	TCCR0A = 0x00u;										// TC0Wō\ݒ
	TCCR0B = ((1 << CS01) | (1<< CS00));				// 32TC0n
	TIMSK0 = ((1 << OCIE0A) | (1<< TOIE0));				// TC0ƔrAv̊荞݂
	OCR0A = 0x01u;										// r(ĳPWMޭè )lݒ
}/*timer_init*/

/*! \brief LED쓮悤߰ ݂o͂Ɍ`Ԑݒ
 *
 *  \param	void
 *  \return	void
 */
static void configure_port_pins(void)
{
	REG(DDR , LED_0_PORT) |= (1 << LED_0_PIN);
}/*configure_port_pins*/

/* == I֐(S֐)` ================================================ */

/*! \brief ֐ */
int main(void)
{
	uint8_t timer_running  =  0u;
	uint8_t slider_position;

	configure_prescaler(DEF_MCU_CLOCK_PRESCALER);	//  ۯOu`Ԑݒ
	timer_init();									// /2`Ԑݒ
	timer_running = 1u;
	cpu_irq_enable();								// S̊荞݋
	touch_sensors_init();							// QTouchײ؏ƐڐGm`Ԑݒ
	configure_port_pins();

	while(1){
		touch_sensors_measure();
		if ((p_selfcap_measure_data->measurement_done_touch == 1u))
		{
			p_selfcap_measure_data->measurement_done_touch = 0u;
			slider_position= GET_SELFCAP_ROTOR_SLIDER_POSITION(0);
			
			if(slider_position < 3 )
			{
				timer_running =0u;
				TIMSK0 = 0x0u;							// /0荞݋֎~
				TIFR0 = ((1 << OCF0A) | (1<< TOV0));	// ۗ荞ݗv׸މ
				RESET_GPIO_PIN(LED_0_PORT,LED_0_PIN);	// LED(o=L)
			}else if(slider_position > 252 )
			{
				timer_running =0u;
				TIMSK0 = 0x0u;							// /0荞݋֎~
				TIFR0 = ((1 << OCF0A) | (1<< TOV0));	// ۗ荞ݗv׸މ
				SET_GPIO_PIN(LED_0_PORT,LED_0_PIN);		// LEDS](o=H)
			/* 
				# qʒu3ȂALEDOFF
				# qʒu252𒴂Ă΁ALED͒ION
				# qʒu5`252̎ɐqʒuĳPWMޭè 
				# qʒu2`4͖ωȀ˽ؼ^ȂꍇA
				# qʒu<3>3̊ԂŐU鎞LED_()ł傤B
				# : 24ŁA2LEDOFFɂ̂s邩ŏɍsA4LED
				# ONɂĂ̑̕s܂B
			*/
			}else if((slider_position <= 252) && (slider_position >= 5))
			{
				if(!timer_running)
				{
					timer_running = 1u;
					TIFR0 = ((1 << OCF0A) | (1<< TOV0));	// ۗ荞ݗv׸މ
					TIMSK0 = ((1 << OCIE0A) | (1<< TOIE0));	// TC0荞ݍċ(ĊJ)
				}
				OCR0A = slider_position;					// qʒurAl
			}
		}/*if*/
	}/*while*/
}/*main*/

/* == 荞 ============================================================== */

/*! \brief /2rAv荞ݏٰ */
ISR(TIMER2_COMPA_vect)
{
	TIFR2 |= OCF2A;							// TC2rAv荞ݗv׸މ
	/* TC2rAvōs͂ōsĂB */
	if (touch_time_counter == touch_time.measurement_period_ms)
	{
		touch_time.time_to_measure_touch = 1u;
		touch_time.current_time_ms = touch_time.current_time_ms +
									 touch_time.measurement_period_ms;
		touch_time_counter = 0u;
	}else
	{
		touch_time_counter++;
	}
}/*ISR(TIMER2_COMPA_vect)*/
